
import java.rmi.*;
import java.rmi.server.*;
import java.rmi.registry.*;

public class HelloGiver implements GreetingGiver {

    public HelloGiver() {
        super();
    }

    public String giveGreeting(Friendly obj) {
        System.out.println("Giving a greeting to obj: " + obj);
        return "Hi " + obj.getName();
    }

    public static void main(String[] args) {
        if (System.getSecurityManager() == null) {
            System.setSecurityManager(new SecurityManager());
        }
        try {
            int port = 3944; // registry prt: above 1024 so that we can run it.
            String name = "Hello";
            HelloGiver h = new HelloGiver();
            GreetingGiver stub = (GreetingGiver) UnicastRemoteObject.exportObject(h, 0);
            Registry registry = LocateRegistry.getRegistry(port);
            registry.rebind(name, stub);
            System.out.println("HelloGiver bound and ready to give greetings");
        } catch (Exception e) {
            System.err.println("HelloGiver exception:");
            e.printStackTrace();
        }
    }

}