import java.io.*;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;

public class HelloPerson {
    public static void main(String args[]) {
        if (System.getSecurityManager() == null) {
            System.setSecurityManager(new SecurityManager());
        }
        try {
            String name = "Hello";
            int port = 3944; // registry port: we must match the server
            Registry registry = LocateRegistry.getRegistry(args[0], port);
            GreetingGiver g = (GreetingGiver) registry.lookup(name);
            Friendly f = new Tom();
            String result = g.giveGreeting(f);
            System.out.println("Result: " + result);
        } catch (Exception e) {
            System.err.println("HelloPerson exception:");
            e.printStackTrace();
        }
    }    


    private static class Tom implements Friendly, Serializable {
        public String getName() {
            return "Tom";
        }
    }
}
